<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="机器人编号，用于后续上传上位平台或多机器人汇聚识别" prop="robotCode">
        <el-input
          v-model="queryParams.robotCode"
          placeholder="请输入机器人编号，用于后续上传上位平台或多机器人汇聚识别"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="会话ID" prop="sessionId">
        <el-input
          v-model="queryParams.sessionId"
          placeholder="请输入会话ID"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="提问时间" prop="askTime">
        <el-date-picker clearable
          v-model="queryParams.askTime"
          type="date"
          value-format="YYYY-MM-DD"
          placeholder="请选择提问时间">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="命中方式" prop="hitType">
        <el-select v-model="queryParams.hitType" placeholder="请选择命中方式" clearable>
          <el-option
            v-for="dict in hit_type"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="来源场景" prop="sceneType">
        <el-select v-model="queryParams.sceneType" placeholder="请选择来源场景" clearable>
          <el-option
            v-for="dict in scene_type"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="结果状态" prop="resultStatus">
        <el-select v-model="queryParams.resultStatus" placeholder="请选择结果状态" clearable>
          <el-option
            v-for="dict in result_status"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="Plus"
          @click="handleAdd"
          v-hasPermi="['base:dialogueLog:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="Edit"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['base:dialogueLog:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="Delete"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['base:dialogueLog:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="Download"
          @click="handleExport"
          v-hasPermi="['base:dialogueLog:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="dialogueLogList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="主键ID" align="center" prop="id" />
      <el-table-column label="机器人编号，用于后续上传上位平台或多机器人汇聚识别" align="center" prop="robotCode" />
      <el-table-column label="会话ID" align="center" prop="sessionId" />
      <el-table-column label="提问时间" align="center" prop="askTime" width="180">
        <template #default="scope">
          <span>{{ parseTime(scope.row.askTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="用户问题" align="center" prop="question" />
      <el-table-column label="回答摘要" align="center" prop="answerSummary" />
      <el-table-column label="命中方式" align="center" prop="hitType">
        <template #default="scope">
          <dict-tag :options="hit_type" :value="scope.row.hitType"/>
        </template>
      </el-table-column>
      <el-table-column label="来源场景" align="center" prop="sceneType">
        <template #default="scope">
          <dict-tag :options="scene_type" :value="scope.row.sceneType"/>
        </template>
      </el-table-column>
      <el-table-column label="结果状态" align="center" prop="resultStatus">
        <template #default="scope">
          <dict-tag :options="result_status" :value="scope.row.resultStatus"/>
        </template>
      </el-table-column>
      <el-table-column label="失败原因或错误信息" align="center" prop="errorMsg" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['base:dialogueLog:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['base:dialogueLog:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改对话日志对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="dialogueLogRef" :model="form" :rules="rules" label-width="100px">
        <el-row>
        </el-row>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="DialogueLog">
import { listDialogueLog, getDialogueLog, delDialogueLog, addDialogueLog, updateDialogueLog } from "@/api/base/dialogueLog"

const { proxy } = getCurrentInstance()
const { scene_type, result_status, hit_type } = useDict('scene_type', 'result_status', 'hit_type')

const dialogueLogList = ref([])
const open = ref(false)
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const total = ref(0)
const title = ref("")

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    robotCode: undefined,
    sessionId: undefined,
    askTime: undefined,
    question: undefined,
    answer: undefined,
    answerSummary: undefined,
    hitType: undefined,
    sceneType: undefined,
    resultStatus: undefined,
    errorMsg: undefined,
    rawRequest: undefined,
    rawResponse: undefined,
  },
  rules: {
  }
})

const { queryParams, form, rules } = toRefs(data)

/** 查询对话日志列表 */
function getList() {
  loading.value = true
  listDialogueLog(queryParams.value).then(response => {
    dialogueLogList.value = response.rows
    total.value = response.total
    loading.value = false
  })
}

/** 取消按钮 */
function cancel() {
  open.value = false
  reset()
}

/** 表单重置 */
function reset() {
  form.value = {
    id: null,
    robotCode: null,
    sessionId: null,
    askTime: null,
    question: null,
    answer: null,
    answerSummary: null,
    hitType: null,
    sceneType: null,
    resultStatus: null,
    errorMsg: null,
    rawRequest: null,
    rawResponse: null,
    createTime: null
  }
  proxy.resetForm("dialogueLogRef")
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1
  getList()
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef")
  handleQuery()
}

/** 多选框选中数据 */
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 新增按钮操作 */
function handleAdd() {
  reset()
  open.value = true
  title.value = "添加对话日志"
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset()
  const _id = row.id || ids.value
  getDialogueLog(_id).then(response => {
    form.value = response.data
    open.value = true
    title.value = "修改对话日志"
  })
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["dialogueLogRef"].validate(valid => {
    if (valid) {
      if (form.value.id != null) {
        updateDialogueLog(form.value).then(() => {
          proxy.$modal.msgSuccess("修改成功")
          open.value = false
          getList()
        })
      } else {
        addDialogueLog(form.value).then(() => {
          proxy.$modal.msgSuccess("新增成功")
          open.value = false
          getList()
        })
      }
    }
  })
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value
  proxy.$modal.confirm('是否确认删除对话日志编号为"' + _ids + '"的数据项？').then(function() {
    return delDialogueLog(_ids)
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess("删除成功")
  }).catch(() => {})
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('base/dialogueLog/export', {
    ...queryParams.value
  }, `dialogueLog_${new Date().getTime()}.xlsx`)
}

getList()
</script>
